package com.rafkind.reft;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.PrintStream;

import java.util.Properties;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Vector;

import java.lang.reflect.Method;

import java.net.Socket;

import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ContainerListener;
import java.awt.event.ContainerEvent;
import java.awt.Color;

import java.awt.Frame;
import java.awt.Container;
import java.awt.BorderLayout;

import javax.swing.event.MouseInputAdapter;
import java.awt.event.MouseEvent;

import org.swixml.SwingEngine;

import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import javax.swing.Popup;
import javax.swing.PopupFactory;
import javax.swing.filechooser.FileFilter;
import javax.swing.AbstractAction;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JProgressBar;
import javax.swing.JComponent;
import javax.swing.JRadioButton;
import javax.swing.BorderFactory;
import javax.swing.JTextField;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JFileChooser;
import javax.swing.JList;
import javax.swing.JTree;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeModel;
// import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.JSplitPane;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.Box;
import javax.swing.SwingUtilities;

import rheise.jftpd.FTPException;

// import net.sf.ooweb.annotations.Controller;
import net.sf.ooweb.Configuration;
import net.sf.ooweb.HTTP;

public class Reft extends JFrame {

	private JTabbedPane uploads;
	private JTabbedPane downloads;
	private int listenPort;

	private static final int DIRECTORY = 1;
	private static final int FILE = 0;
	public static final int DEFAULT_REFT_PORT = 4949;
		
	private net.sf.ooweb.Server httpserver;
	private rheise.jftpd.Server ftpserver;

	private static final int YES = 1;
	private static final int NO = 0;

	private static final int FILENAME_SIZE = 1024;

	public Reft() throws IOException {
		super( "Reft" );
		this.setSize( 600, 450 );
		final Reft reft = this;
		listenPort = DEFAULT_REFT_PORT;
			
		JTabbedPane mainPain = new JTabbedPane();
		this.getContentPane().add( mainPain );

		SwingEngine engine = new SwingEngine( "reft.xml" );

		JPanel front = (JPanel) engine.getRootComponent();

		mainPain.add( front, "Reft" );

		JMenuBar menuBar = new JMenuBar();
		JMenu programMenu = new JMenu( "Program" );
		JMenu portMenu = new JMenu( "Settings" );
		JMenu helpMenu = new JMenu( "Help" );
		menuBar.add( programMenu );
		menuBar.add( portMenu );
		menuBar.add( helpMenu );
		this.setJMenuBar( menuBar );

		JMenuItem help = new JMenuItem( "Help" );
		helpMenu.add( help );
		help.addActionListener( new ActionListener(){
			public void actionPerformed( ActionEvent action ){
				JDialog help = new HelpDialog();
				help.setLocation( reft.getLocationOnScreen() );
				help.setVisible( true );
			}
		});

		uploads = (JTabbedPane) engine.find( "uploads" );
		downloads = (JTabbedPane) engine.find( "downloads" );

		Lambda2 sendFileLambda = new Lambda2(){
			public Object invoke( Object arg1, Object arg2 ){
				sendFile( (Buddy) arg1, (File[]) arg2 );
				return null;
			}
		};

		JPanel buddyList = (JPanel) engine.find( "buddylist" );
		buddyList.add( BuddyList.createBuddyList( sendFileLambda ) );

		Lambda1 addClient = new Lambda1(){
			public Object invoke( Object arg ){
				Socket client = (Socket) arg;

				addClient( client );

				return null;
			}
		};

		ServerThread serverThread;
		try{
			serverThread = new ServerThread( this.getListenPort(), addClient );
		} catch ( IOException ie ){
			System.out.println( "Could not bind to " + getListenPort() );
			ie.printStackTrace();
			serverThread = new ServerThread( 0, addClient );
		}

		final ServerThread server = serverThread;

		JMenuItem setPort = new JMenuItem( "Set port" );
		setPort.addActionListener( new ActionListener(){
			public void actionPerformed( ActionEvent action ){
				final JDialog dialog = new JDialog( reft );
				Box all = Box.createVerticalBox();
				dialog.getContentPane().add( all );

				dialog.setLocation( reft.getLocationOnScreen() );

				Box portBox = Box.createHorizontalBox();
				all.add( portBox );
				portBox.add( new JLabel( "Port" ) );
				portBox.add( Box.createHorizontalStrut( 5 ) );
				final JTextField port = new JTextField( String.valueOf( getListenPort() ) );
				portBox.add( port );
				portBox.add( Box.createHorizontalStrut( 5 ) );

				all.add( Box.createVerticalStrut( 10 ) );

				final Lambda0 close = new Lambda0(){
					public Object invoke(){
						dialog.dispose();
						return null;
					}
				};

				Box buttons = Box.createHorizontalBox();
				all.add( buttons );
				JButton set = new JButton( "Set port" );
				set.addActionListener( new ActionListener(){
					public void actionPerformed( ActionEvent action ){
						try{
							int portNum = Integer.parseInt( port.getText() );
							setListenPort( portNum );
							server.setPort( portNum );
							close.invoke();
						} catch ( Exception e ){
							System.out.println( "Couldnt change port" );
							e.printStackTrace();
						}
					}
				});
				buttons.add( set );
				buttons.add( Box.createHorizontalStrut( 5 ) );
				JButton exit = new JButton( "Close Window" );
				exit.addActionListener( new ActionListener(){
					public void actionPerformed( ActionEvent action ){
						try{
							close.invoke();
						} catch ( Exception ex ){
						}
					}
				});
				buttons.add( exit );
				
				dialog.setSize( 300, 100 );
				dialog.setVisible( true );
			}
		});
		portMenu.add( setPort );

		final Lambda0 close = new Lambda0(){
			public Object invoke(){
				Frame[] frames = reft.getFrames();

				for ( int i = 0; i < frames.length; i++ ){
					frames[ i ].dispose();
				}

				server.kill();

				/* hard kill */
				// System.exit( 0 );

				// reft.dispose();
				System.exit( 0 );
				return null;
			}
		};

		JMenuItem programClose = new JMenuItem( "Quit" );
		programMenu.add( programClose );
		programClose.addActionListener( new ActionListener(){
			public void actionPerformed( ActionEvent action ){
				close.invoke_();
			}
		});
		
		serverThread.start();

		FileManager ftpManager = new FileManager();

		mainPain.add( createHTTPPane(), "HTTP" );
		// mainPain.add( createFTPPane( ftpManager ), "FTP" );
		mainPain.add( createFTPPane(), "FTP" );
		
		this.addWindowListener( new CloseHook( close ) );
	}

	private JPanel createFTPPane2( final FileManager manager ){
		final Reft reft = this;

		SwingEngine engine = new SwingEngine( "ftp.xml" );

		JPanel ftpPanel = (JPanel) engine.getRootComponent();

		JButton addFile = (JButton) engine.find( "add" );
		JButton deleteFile = (JButton) engine.find( "delete" );
		final JList files = (JList) engine.find( "fileList" );
		// final JTree files = (JTree) engine.find( "fileList" );
		// final TreeModel fileTree = new FileTree();
		// files.setModel( fileTree );

		final Vector fileList = new Vector();
		
		final JTextField serverNameField = (JTextField) engine.find( "server" );
		serverNameField.setText( "localhost" );
		
		final JTextField url = (JTextField) engine.find( "url" );
		final JTextField browse = (JTextField) engine.find( "browse" );
		final JTextArea logs = (JTextArea) engine.find( "log" );
		final StringBuffer messages = new StringBuffer();
		
		final JTextField ftpPortField = (JTextField) engine.find( "port" );
		ftpPortField.setText( "4051" );

		final Lambda1 addMessage = new Lambda1(){
			public Object invoke( Object s ){
				String message = (String) s;
				messages.append( message ).append( "\n" );
				logs.setText( messages.toString() );
				return null;
			}
		};

		addFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				JFileChooser chooser = new JFileChooser();
				chooser.setMultiSelectionEnabled( true );
				chooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
				int returnVal = chooser.showOpenDialog( reft );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					File[] selected = chooser.getSelectedFiles();
					for ( int i = 0; i < selected.length; i++ ){
						File f = selected[ i ];
						if ( f.isFile() ){
							manager.addFile( "/root", f );
							fileList.add( f );
						} else {
							List all = traverseDirectory( f );
							try{
								Lambda1.foreach( all, new Lambda1(){
									public Object invoke( Object file ){
																				manager.addFile( "/root", (File) file );
																				return null;
									}
								});
							} catch ( Exception e ){
							}
							fileList.addAll( all );
						}
					}
					files.setListData( fileList );
				}
			}
		});

		deleteFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				Object[] items = files.getSelectedValues();
				for ( int i = 0; i < items.length; i++ ){
					manager.removeFile( "/root", (File) items[ i ] );
					fileList.remove( items[ i ] );
				}
				files.setListData( fileList );
			}
		});
		
		final JRadioButton on = (JRadioButton) engine.find( "on" );
		final JRadioButton off = (JRadioButton) engine.find( "off" );
		off.setSelected( true );

		final MutableBoolean serverIsOn = new MutableBoolean( false );

		on.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isFalse() ){
					try{
						try{
							int i = Integer.parseInt( ftpPortField.getText() );
							// startFTPServer( manager, i );
							serverIsOn.setTrue();
							addMessage.invoke( "Started ftp server on port " + i );
						} catch ( NumberFormatException ne ){
							addMessage.invoke( "Couldn't restart FTP server on port '" + ftpPortField.getText() + "'" );
						}
					} catch ( Exception e ){
						e.printStackTrace();
					}
				}
			}
		});

		off.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isTrue() ){
					try{
						stopFTPServer();
						serverIsOn.setFalse();
						addMessage.invoke( "Stopped FTP server" );
					} catch ( Exception e ){
						e.printStackTrace();
					}
				}
			}
		});

		final MutableString serverName = new MutableString( "localhost" );

		final Lambda0 setBrowse = new Lambda0(){
			public Object invoke(){
				browse.setText( "ftp://" + serverNameField.getText() + ":" + ftpPortField.getText() + "/" );
				return null;
			}
		};


		final Lambda0 setURL = new Lambda0(){
			public Object invoke(){
				if ( files.getSelectedIndex() != -1 ){
					File f = (File) fileList.get( files.getSelectedIndex() );
					url.setText( "ftp://" + serverNameField.getText() + ":" + ftpPortField.getText() + "/" + f.getName() );
				}
				return null;
			}
		};

		ftpPortField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent e ){

				try{
					try{
						int i = Integer.parseInt( ftpPortField.getText() );
						off.setSelected( true );
						// restartFTPServer( manager, i );
						setBrowse.invoke();
						setURL.invoke();
						serverIsOn.setTrue();
						on.setSelected( true );
						addMessage.invoke( "Started ftp server on port " + i );
					} catch ( NumberFormatException ne ){
						addMessage.invoke( "Couldn't restart FTP server on port '" + ftpPortField.getText() + "'" );
					} catch ( FTPException ex ){
						addMessage.invoke( "Could not start FTP server on port '" + ftpPortField.getText() + "'" );
					}
				} catch ( Exception ex ){
					ex.printStackTrace();
				}
			}
		});
		
		files.addListSelectionListener( new ListSelectionListener(){
			public void valueChanged( ListSelectionEvent event ){
				try{
					setURL.invoke();
				} catch ( Exception ex ){
				}
			}
		});

		serverNameField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				serverName.set( serverNameField.getText() );
				try{
					setURL.invoke();
					setBrowse.invoke();
				} catch ( Exception ex ){
				}
			}
		});

		try{
			setBrowse.invoke();
		} catch ( Exception ex ){
		}


		return ftpPanel;
	}

	private JPanel createFTPPane(){

		final Reft reft = this;
		SwingEngine engine = new SwingEngine( "ftp.xml" );
		final JPanel httpPanel = (JPanel) engine.getRootComponent();

		final JTextField serverNameField = (JTextField) engine.find( "server" );
		final int defaultPort = 4051;
		final JTextField portField = (JTextField) engine.find( "port" );

		final StringBuffer messages = new StringBuffer();
		final JTextArea logs = (JTextArea) engine.find( "log" );
		final String persistFilesName = "httpFiles.obj";
		// final JList fileList = (JList) engine.find( "fileList" );
		// final Vector files = (Vector) loadObject( persistFilesName, new Vector() );

		final JTree files = (JTree) engine.find( "fileList" );
		final FileTree fileTree = new FileTree();
		files.setModel( fileTree );

		// fileList.setListData( files );

		files.addKeyListener( new KeyAdapter(){
			public void keyTyped( KeyEvent e ){
				if ( e.getKeyChar() == KeyEvent.VK_DELETE ){
					// System.out.println( "Delete something" );
					TreePath[] selected = files.getSelectionPaths();
					if ( selected != null ){
						fileTree.remove( selected );
					}
				}
			}
		});

		final JRadioButton on = (JRadioButton) engine.find( "on" );
		final JRadioButton off = (JRadioButton) engine.find( "off" );
		off.setSelected( true );

		final MutableBoolean serverIsOn = new MutableBoolean( false );

		final Lambda1 log = new Lambda1(){
			public Object invoke( Object message ){
				messages.append( (String) message ).append( "\n" );
				logs.setText( messages.toString() );
				return null;
			}
		};

		on.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isFalse() ){
					try{
						try{
							int i = Integer.parseInt( portField.getText() );
							serverIsOn.setFalse();
							off.setSelected( true );
							startFTPServer( fileTree, i );
							serverIsOn.setTrue();
							on.setSelected( true );

							log.invoke( "Started FTP server on port " + portField.getText() );
						} catch ( NumberFormatException ne ){
							System.out.println( "Couldn't restart FTP server on port '" + portField.getText() + "'" );
							log.invoke( "Could not start HTTP server on port " + portField.getText() );
						} catch ( IOException ie ){
							ie.printStackTrace();
							log.invoke( "Could not start HTTP server on port " + portField.getText() );
						}
					} catch ( Exception e ){
						e.printStackTrace();
					}
				}
			}
		});

		/* turn off the http server */
		off.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isTrue() ){
					stopFTPServer();
					serverIsOn.setFalse();
					log.invoke_( "FTP Server is off" );
				}
			}
		});
		
		final JTextField browse = (JTextField) engine.find( "browse" );

		final Lambda0 setBrowse = new Lambda0(){
			public Object invoke(){
				browse.setText( "ftp://" + serverNameField.getText() + ":" + portField.getText() + "/" );
				return null;
			}
		};

		portField.setText( String.valueOf( defaultPort ) );
		serverNameField.setText( "localhost" );
		final JTextField url = (JTextField) engine.find( "url" );

		final MutableBoolean keepAdding = new MutableBoolean();

		final JButton addFile = (JButton) engine.find( "add" );
		final JButton deleteFile = (JButton) engine.find( "delete" );
		final JButton stop = (JButton) engine.find( "stop" );

		addFile.setToolTipText( "<html>This button will bring up a new window that lets you select files to share over FTP.<br>Be sure to turn the server on to actually share them.</html>" );

		deleteFile.setToolTipText( "Remove all selected files from the list above." );
		stop.setToolTipText( "When many files are being added this button lets you stop the addition process" );

		stop.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				keepAdding.setFalse();
			}
		});

		addFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				JFileChooser chooser = new JFileChooser();
				chooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
				chooser.setMultiSelectionEnabled( true );
				int returnVal = chooser.showOpenDialog( reft );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					final File[] myfiles = chooser.getSelectedFiles();

					keepAdding.setTrue();
					stop.setEnabled( true );
					/* a nice shade of red */
					stop.setBackground( new Color( 219, 79, 87 ) );
					addFile.setEnabled( false );

					final Lambda0 continue_ = new Lambda0(){
						public Object invoke(){
							return Boolean.valueOf( keepAdding.getValue() );
						}
					};

					final Lambda2 retain = new Lambda2(){
						public Object invoke( final Object node, final Object children ){
							SwingUtilities.invokeLater( new Runnable(){
								public void run(){
									fileTree.insert( (TreeNode) node, (int[]) children );
									files.expandRow( 0 );
								}
							});
							return null;
						}
					};

					new Thread(){
						public void run(){
							TreePath path = files.getSelectionPath();
							FileTreeNode node = null;
							if ( path == null ){
								node = (FileTreeNode) fileTree.getRoot();
							} else {
								node = (FileTreeNode) path.getLastPathComponent();
							}
							synchronized( fileTree.getRoot() ){
								addFiles( node, myfiles, continue_, retain, 0 );
							}
							// addFiles( fileTree, myfiles, continue_, retain, 0 );
							// retain.invoke_();
							// saveObject( files, persistFilesName );

							SwingUtilities.invokeLater( new Runnable(){
								public void run(){
									// fileTree.update();
									stop.setEnabled( false );
									stop.setBackground( null );
									addFile.setEnabled( true );
								}
							} );
						}
					}.start();
				}
			}
		});

		files.addMouseListener( new MouseInputAdapter(){
			private boolean rightClicked( MouseEvent e ){
				return e.getButton() == MouseEvent.BUTTON3;
			}

			public void mouseClicked( MouseEvent event ){
				if ( rightClicked( event ) ){
					final TreePath path = files.getSelectionPath();
					if ( path != null ){
						FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
						if ( node.isDirectory() ){

							JPanel stuff = new JPanel();
							JButton doit = new JButton( "Add" );
							JButton cancel = new JButton( "Don't Add" );
							Box b1 = Box.createVerticalBox();
							final JTextField text = new JTextField( 10 );
							b1.add( text );
							Box b2 = Box.createHorizontalBox();
							b2.add( doit );
							b2.add( Box.createHorizontalStrut( 3 ) );
							b2.add( cancel );
							b1.add( b2 );
							stuff.add( b1 );
							Point location = new Point();
							location = httpPanel.getLocationOnScreen();
							final Popup add = PopupFactory.getSharedInstance().getPopup( reft, stuff, (int)(location.getX() + event.getX() + 10), (int)(location.getY() + event.getY() + 25) );

							doit.addActionListener( new AbstractAction(){
								public void actionPerformed( ActionEvent event ){
									String s = text.getText().trim();
									if ( s.length() > 0 ){
										FileTreeNode node = new FileTreeNode( s, true );
										FileTreeNode addTo = (FileTreeNode) path.getLastPathComponent();
										addTo.add( node );
										int[] children = new int[ 1 ];
										children[ 0 ] = addTo.getChildCount() - 1;
										fileTree.insert( addTo, children );
									}

									add.hide();
								}

							});
							cancel.addActionListener( new AbstractAction(){
								public void actionPerformed( ActionEvent event ){
									add.hide();
								}
							});
							add.show();
						}
					}
				}
			}
		});

		final Lambda0 doDelete = new Lambda0(){
			public Object invoke(){
				/* stop adding files and delete the selected paths
				 */
				keepAdding.setFalse();
				synchronized( fileTree.getRoot() ){
					TreePath[] paths = files.getSelectionPaths();
					fileTree.removeAll( paths );
				}

				return null;
			}
		};

		deleteFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				doDelete.invoke_();
			}
		});

		final MutableString serverName = new MutableString( "localhost" );

		final Lambda0 setURL = new Lambda0(){
			public Object invoke(){
				TreePath path = files.getSelectionPath();
				if ( path != null ){
					FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
					if ( node.isDirectory() ){
						url.setText( "ftp://" + serverNameField.getText() + ":" + portField.getText() + node.getLineage() + "/" );
					} else {
						StringBuffer buffer = new StringBuffer();
						buffer.append( "ftp://" );
						buffer.append( serverNameField.getText() );
						buffer.append( ":" );
						buffer.append( portField.getText() );
						buffer.append( ((FileTreeNode) node.getParent()).getLineage() );
						buffer.append( "/" );
						buffer.append( node.getName() );
						url.setText( buffer.toString() );
					}
				}
				return null;
			}
		};

		files.addTreeSelectionListener( new TreeSelectionListener(){
			public void valueChanged( TreeSelectionEvent event ){
				TreePath path = event.getPath();
				if ( path != null ){
					FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
					addFile.setEnabled( node.isDirectory() );
					setURL.invoke_();
				} else {
					addFile.setEnabled( true );
				}
			}
		});

		files.addKeyListener( new KeyAdapter(){
			public void keyTyped( KeyEvent e ){
				if ( e.getKeyChar() == KeyEvent.VK_DELETE ){
					doDelete.invoke_();
				}
			}
		});

		portField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent e ){
				try{
					int i = Integer.parseInt( portField.getText() );
					serverIsOn.setFalse();
					off.setSelected( true );
					restartFTPServer( fileTree, i );
					serverIsOn.setTrue();
					setURL.invoke_();
					setBrowse.invoke_();
					on.setSelected( true );

					log.invoke_( "Started FTP server on port " + i );
				} catch ( NumberFormatException ne ){
					System.out.println( "Couldn't restart FTP server on port '" + portField.getText() + "'" );
					log.invoke_( "Could not start FTP server on port " + portField.getText() );
				} catch ( FTPException ie ){
					log.invoke_( "Could not start FTP server on port " + portField.getText() );
				}
			}
		});


		serverNameField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				serverName.set( serverNameField.getText() );
				setURL.invoke_();
				setBrowse.invoke_();
			}
		});

		setBrowse.invoke_();

		// startHTTPServer( files, 4050 );

		return httpPanel;
	}

	private JPanel createHTTPPane(){

		final Reft reft = this;
		SwingEngine engine = new SwingEngine( "http.xml" );
		final JPanel httpPanel = (JPanel) engine.getRootComponent();

		final JTextField serverNameField = (JTextField) engine.find( "server" );
		final JTextField httpPortField = (JTextField) engine.find( "port" );

		final StringBuffer messages = new StringBuffer();
		final JTextArea logs = (JTextArea) engine.find( "log" );
		final String persistFilesName = "httpFiles.obj";
		// final JList fileList = (JList) engine.find( "fileList" );
		// final Vector files = (Vector) loadObject( persistFilesName, new Vector() );

		final JTree files = (JTree) engine.find( "fileList" );
		final FileTree fileTree = new FileTree();
		files.setModel( fileTree );

		// fileList.setListData( files );

		files.addKeyListener( new KeyAdapter(){
			public void keyTyped( KeyEvent e ){
				if ( e.getKeyChar() == KeyEvent.VK_DELETE ){
					// System.out.println( "Delete something" );
					TreePath[] selected = files.getSelectionPaths();
					if ( selected != null ){
						fileTree.remove( selected );
					}
				}
			}
		});

		final JRadioButton on = (JRadioButton) engine.find( "on" );
		final JRadioButton off = (JRadioButton) engine.find( "off" );
		off.setSelected( true );

		final MutableBoolean serverIsOn = new MutableBoolean( false );

		final Lambda1 log = new Lambda1(){
			public Object invoke( Object message ){
				messages.append( (String) message ).append( "\n" );
				logs.setText( messages.toString() );
				return null;
			}
		};

		on.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isFalse() ){
					try{
						try{
							int i = Integer.parseInt( httpPortField.getText() );
							serverIsOn.setFalse();
							off.setSelected( true );
							startHTTPServer( fileTree, i );
							serverIsOn.setTrue();
							on.setSelected( true );

							log.invoke( "Started HTTP server on port " + httpPortField.getText() );
						} catch ( NumberFormatException ne ){
							System.out.println( "Couldn't restart HTTP server on port '" + httpPortField.getText() + "'" );
							log.invoke( "Could not start HTTP server on port " + httpPortField.getText() );
						} catch ( IOException ie ){
							ie.printStackTrace();
							log.invoke( "Could not start HTTP server on port " + httpPortField.getText() );
						}
					} catch ( Exception e ){
						e.printStackTrace();
					}
				}
			}
		});

		/* turn off the http server */
		off.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent ae ){
				if ( serverIsOn.isTrue() ){
					stopHTTPServer();
					serverIsOn.setFalse();
					log.invoke_( "HTTP Server is off" );
				}
			}
		});
		
		final JTextField browse = (JTextField) engine.find( "browse" );

		final Lambda0 setBrowse = new Lambda0(){
			public Object invoke(){
				browse.setText( "http://" + serverNameField.getText() + ":" + httpPortField.getText() + "/" );
				return null;
			}
		};

		httpPortField.setText( "4050" );
		serverNameField.setText( "localhost" );
		final JTextField url = (JTextField) engine.find( "url" );

		final MutableBoolean keepAdding = new MutableBoolean();

		final JButton addFile = (JButton) engine.find( "add" );
		final JButton deleteFile = (JButton) engine.find( "delete" );
		final JButton stop = (JButton) engine.find( "stop" );

		addFile.setToolTipText( "<html>This button will bring up a new window that lets you select files to share over HTTP.<br>Be sure to turn the server on to actually share them.</html>" );

		deleteFile.setToolTipText( "Remove all selected files from the list above." );
		stop.setToolTipText( "When many files are being added this button lets you stop the addition process" );

		stop.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				keepAdding.setFalse();
			}
		});

		addFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				JFileChooser chooser = new JFileChooser();
				chooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
				chooser.setMultiSelectionEnabled( true );
				int returnVal = chooser.showOpenDialog( reft );
				if ( returnVal == JFileChooser.APPROVE_OPTION ){
					final File[] myfiles = chooser.getSelectedFiles();

					keepAdding.setTrue();
					stop.setEnabled( true );
					/* a nice shade of red */
					stop.setBackground( new Color( 219, 79, 87 ) );
					addFile.setEnabled( false );

					final Lambda0 continue_ = new Lambda0(){
						public Object invoke(){
							return Boolean.valueOf( keepAdding.getValue() );
						}
					};

					final Lambda2 retain = new Lambda2(){
						public Object invoke( final Object node, final Object children ){
							SwingUtilities.invokeLater( new Runnable(){
								public void run(){
									fileTree.insert( (TreeNode) node, (int[]) children );
									files.expandRow( 0 );
								}
							});
							return null;
						}
					};

					new Thread(){
						public void run(){
							TreePath path = files.getSelectionPath();
							FileTreeNode node = null;
							if ( path == null ){
								node = (FileTreeNode) fileTree.getRoot();
							} else {
								node = (FileTreeNode) path.getLastPathComponent();
							}
							synchronized( fileTree.getRoot() ){
								addFiles( node, myfiles, continue_, retain, 0 );
							}
							// addFiles( fileTree, myfiles, continue_, retain, 0 );
							// retain.invoke_();
							// saveObject( files, persistFilesName );

							SwingUtilities.invokeLater( new Runnable(){
								public void run(){
									// fileTree.update();
									stop.setEnabled( false );
									stop.setBackground( null );
									addFile.setEnabled( true );
								}
							} );
						}
					}.start();
				}
			}
		});

		files.addMouseListener( new MouseInputAdapter(){
			private boolean rightClicked( MouseEvent e ){
				return e.getButton() == MouseEvent.BUTTON3;
			}

			public void mouseClicked( MouseEvent event ){
				if ( rightClicked( event ) ){
					final TreePath path = files.getSelectionPath();
					if ( path != null ){
						FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
						if ( node.isDirectory() ){

							JPanel stuff = new JPanel();
							JButton doit = new JButton( "Add" );
							JButton cancel = new JButton( "Don't Add" );
							Box b1 = Box.createVerticalBox();
							final JTextField text = new JTextField( 10 );
							b1.add( text );
							Box b2 = Box.createHorizontalBox();
							b2.add( doit );
							b2.add( Box.createHorizontalStrut( 3 ) );
							b2.add( cancel );
							b1.add( b2 );
							stuff.add( b1 );
							Point location = new Point();
							location = httpPanel.getLocationOnScreen();
							final Popup add = PopupFactory.getSharedInstance().getPopup( reft, stuff, (int)(location.getX() + event.getX() + 10), (int)(location.getY() + event.getY() + 25) );

							doit.addActionListener( new AbstractAction(){
								public void actionPerformed( ActionEvent event ){
									String s = text.getText().trim();
									if ( s.length() > 0 ){
										FileTreeNode node = new FileTreeNode( s, true );
										FileTreeNode addTo = (FileTreeNode) path.getLastPathComponent();
										addTo.add( node );
										int[] children = new int[ 1 ];
										children[ 0 ] = addTo.getChildCount() - 1;
										fileTree.insert( addTo, children );
									}

									add.hide();
								}

							});
							cancel.addActionListener( new AbstractAction(){
								public void actionPerformed( ActionEvent event ){
									add.hide();
								}
							});
							add.show();
						}
					}
				}
			}
		});

		final Lambda0 doDelete = new Lambda0(){
			public Object invoke(){
				/* stop adding files and delete the selected paths
				 */
				keepAdding.setFalse();
				synchronized( fileTree.getRoot() ){
					TreePath[] paths = files.getSelectionPaths();
					fileTree.removeAll( paths );
				}

				return null;
			}
		};

		deleteFile.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				doDelete.invoke_();
			}
		});

		final MutableString serverName = new MutableString( "localhost" );

		final Lambda0 setURL = new Lambda0(){
			public Object invoke(){
				TreePath path = files.getSelectionPath();
				if ( path != null ){
					FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
					if ( node.isDirectory() ){
						url.setText( "http://" + serverNameField.getText() + ":" + httpPortField.getText() + node.getLineage() + "/" );
					} else {
						StringBuffer buffer = new StringBuffer();
						buffer.append( "http://" );
						buffer.append( serverNameField.getText() );
						buffer.append( ":" );
						buffer.append( httpPortField.getText() );
						buffer.append( ((FileTreeNode) node.getParent()).getLineage() );
						buffer.append( "/file?id=" );
						buffer.append( node.getParent().getIndex( node ) );
						url.setText( buffer.toString() );
					}
				}
				return null;
			}
		};

		files.addTreeSelectionListener( new TreeSelectionListener(){
			public void valueChanged( TreeSelectionEvent event ){
				TreePath path = event.getPath();
				if ( path != null ){
					FileTreeNode node = (FileTreeNode) path.getLastPathComponent();
					addFile.setEnabled( node.isDirectory() );
					setURL.invoke_();
				} else {
					addFile.setEnabled( true );
				}
			}
		});

		files.addKeyListener( new KeyAdapter(){
			public void keyTyped( KeyEvent e ){
				if ( e.getKeyChar() == KeyEvent.VK_DELETE ){
					doDelete.invoke_();
				}
			}
		});

		httpPortField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent e ){
				try{
					int i = Integer.parseInt( httpPortField.getText() );
					serverIsOn.setFalse();
					off.setSelected( true );
					restartHTTPServer( fileTree, i );
					serverIsOn.setTrue();
					setURL.invoke_();
					setBrowse.invoke_();
					on.setSelected( true );

					log.invoke_( "Started HTTP server on port " + i );
				} catch ( NumberFormatException ne ){
					System.out.println( "Couldn't restart HTTP server on port '" + httpPortField.getText() + "'" );
					log.invoke_( "Could not start HTTP server on port " + httpPortField.getText() );
				} catch ( IOException ie ){
					log.invoke_( "Could not start HTTP server on port " + httpPortField.getText() );
				}
			}
		});


		serverNameField.addActionListener( new AbstractAction(){
			public void actionPerformed( ActionEvent event ){
				serverName.set( serverNameField.getText() );
				setURL.invoke_();
				setBrowse.invoke_();
			}
		});

		setBrowse.invoke_();

		// startHTTPServer( files, 4050 );

		return httpPanel;
	}

	/* add files in a breadth first search fashion */
	private int addFiles( FileTreeNode parent, File[] files, Lambda0 continue_, Lambda2 set, int num ){
		List dirs = new ArrayList();
		int top = parent.getChildCount();
		int last = 0;
		int count = num;
		for ( int i = 0; i < files.length; i++ ){
			if ( ! ((Boolean) continue_.invoke_()).booleanValue() ){
				return count;
			}
			File f = files[ i ];
			count += 1;
			FileTreeNode node = new FileTreeNode( f );
			parent.add( node );
			if ( f.isDirectory() ){
				dirs.add( new Object[]{ node, f } );
			}
			/* every 50 iterations update the gui */
			if ( count >= 50 ){
				count = 0;
				int[] children = new int[ i - last ];
				for ( int q = last; q < i; q++ ){
					children[ q - last ] = top + q - last;
				}
				top += i - last;
				last = i;
				set.invoke_( parent, children );
				// System.out.println( "Setting top to " + top + " Last = " + last );
			}
		}
		int[] children = new int[ files.length - last ];
		// System.out.println( "Parent = " + parent + " Top: " + top + " Children = " + parent.getChildCount() + " Adding from " + last + " to " + files.length );
		for ( int q = last; q < files.length; q++ ){
			children[ q - last ] = top + q - last;
		}
		set.invoke_( parent, children );

		for ( Iterator iterator = dirs.iterator(); iterator.hasNext(); ){
			Object[] o = (Object[]) iterator.next();
			FileTreeNode node = (FileTreeNode) o[ 0 ];
			File f = (File) o[ 1 ];
			File[] more = f.listFiles();
			Arrays.sort( more );
			count = addFiles( node, more, continue_, set, count );
		}

		return count;
	}

	private List traverseDirectory( File dir ){
		List all = new ArrayList();

		File[] files = dir.listFiles();
		for ( int i = 0; i < files.length; i++ ){
			if ( ! files[ i ].isDirectory() ){
				all.add( files[ i ] );
			} else {
				all.addAll( traverseDirectory( files[ i ] ) );
			}
		}

		return all;
	}

	private Object loadObject( String file, Object default_ ){
		try{
			return (new ObjectInputStream( new FileInputStream( file ) ).readObject());
		} catch ( Exception e ){
			return default_;
		}
	}

	private void saveObject( Object obj, String file ){
		try{
			new ObjectOutputStream( new FileOutputStream( file ) ).writeObject( obj );
		} catch ( Exception e ){
			/* wha-wha-wha-whatever */
		}
	}

	private synchronized void stopHTTPServer(){
		if ( httpserver != null ){
			httpserver.shutdown();
		}
	}

	private synchronized void startFTPServer( final FileTree manager, int port ) throws FTPException {
		Properties properties = new Properties();
		ftpserver = new rheise.jftpd.Server( properties, port );
		new Thread(){
			public void run(){
				ftpserver.start( manager );
			}
		}.start();
	}

	private void restartFTPServer( FileTree manager, int port ) throws FTPException {
		stopFTPServer();
		startFTPServer( manager, port );
	}

	private synchronized void stopFTPServer(){
		if ( ftpserver != null ){
			ftpserver.stop();
		}
	}

	private synchronized void restartHTTPServer( final FileTree files, int port ) throws IOException {
		stopHTTPServer();
		startHTTPServer( files, port );
	}

	private Object createNodeHandler( final FileTree fileTree, final FileTreeNode node ){
		return new Object(){

			private double reduce( double num ){
				return ((int)( num * 100 )) / 100.0;
			}

			private String niceSize( long size ){
				if ( size < 1024 ){
					return String.valueOf( size );
				} else if ( size < 1024 * 1024 ){
					return String.valueOf( reduce( size / 1024.0 ) ) + "k";	
				} else if ( size < 1024 * 1024 * 1024 ){
					return String.valueOf( reduce( size / ( 1024.0 * 1024.0 ) ) ) + "m";
				} else {
					return String.valueOf( reduce( size / ( 1024.0 * 1024.0 * 1024.0 ) ) ) + "g";
				}
			}

			public String index(){
				synchronized( fileTree.getRoot() ){
					List files = node.getFiles();
					StringBuffer result = new StringBuffer();
					int num = 0;
					String lineage = node.getLineage();

					result.append( "Current directory: " + lineage + "<br />" );
					result.append( "<a href='..'>Go up one directory</a>" );
					result.append( "<br /><br />" );
					result.append( "<table>" );
					result.append( "<tr><td>Name</td><td>Type</td><td>Size</td></tr>" );
					for ( Iterator iterator = files.iterator(); iterator.hasNext(); ){
						FileTreeNode f = (FileTreeNode) iterator.next();
						System.out.println( "Get node for " + f.getName() );
						result.append( "<tr>" );
						if ( f.isDirectory() ){
							result.append( "<td>" );
							result.append( "<a href='"  + lineage + "/" + f.getName() + "/'>" + f.getName() + "/</a>" );
							result.append( "</td><td>Directory</td><td>-</td>" );
						} else {
							result.append( "<td>" );
							result.append( "<a href='" + lineage + "/file?id=" + num + "'>" + f.getName() + "</a>" );
							result.append( "</td><td>File</td>" );
							result.append( "<td>" + niceSize( f.getFile().length() ) + "</td>" );
						}
						result.append( "</tr>" );
						num++;
					}
					result.append( "</table>" );

					return result.toString();
				}
			}

			/* Returns a file. Called when the url is like
			 * http://whatever/foo/file?id=4
			 * Actually the parameter, id, can be an arbitrary name
			 * because ooweb will apply file to the arguments regardless
			 * of their name
			 * (let ((args (parse-query-string)))
			 *   (apply file args))
			 */
			public Object file( String id ){
				HTTP.setMimeType( "application/octet-stream" );
				synchronized( fileTree.getRoot() ){
					try{
						int i = Integer.parseInt( id );
						List files = node.getFiles();
						FileTreeNode f = (FileTreeNode) files.get( i );
						// HTTP.redirect( f.getName() );
						return f;
						// return f.getUserObject();
					} catch ( Exception e ){
						e.printStackTrace();
					}
					return null;
				}
			}
		};
	}

	/* NOT USED */
	private void registerNode( final net.sf.ooweb.Server httpServer, final FileTreeNode node, final String dir, final FileTree fileTree ){

		
		httpServer.register( dir, new Object(){
			public String index(){
				synchronized( fileTree.getRoot() ){
					List files = node.getFiles();
					StringBuffer result = new StringBuffer();
					int num = 0;

					result.append( "Current directory: " + dir + "<br />" );
					result.append( "<a href='..'>Go up one directory</a>" );
					result.append( "<br /><br />" );
					for ( Iterator iterator = files.iterator(); iterator.hasNext(); ){
						FileTreeNode f = (FileTreeNode) iterator.next();
						if ( f.isDirectory() ){
							result.append( "<a href='" + dir + f.getName() + "/'>" + f.getName() + "/</a>" );
						} else {
							result.append( "<a href='" + dir + "file?id=" + num + "'>" + f.getName() + "</a>" );
							num++;
						}
						result.append( "<br />" );
					}

					return result.toString();
				}
			}

			public Object file( String id ){
				HTTP.setMimeType( "application/octet-stream" );
				synchronized( fileTree.getRoot() ){
					try{
						int i = Integer.parseInt( id );
						int count = 0;
						List files = node.getFiles();
						Iterator iterator = files.iterator();
						while ( count < i && iterator.hasNext() ){
							FileTreeNode f = (FileTreeNode) iterator.next();
							if ( ! f.isDirectory() ){
								count += 1;
							}
						}
						FileTreeNode f = (FileTreeNode) files.get( i );
						// HTTP.redirect( f.getName() );
						// return f.getUserObject();
						// System.out.println( "Returning " + f.getClass().toString() );
						return f;
					} catch ( Exception e ){ }
					return null;
				}
			}
		});

		List directories = node.getDirectories();
		for ( Iterator iterator = directories.iterator(); iterator.hasNext(); ){
			FileTreeNode dNode = (FileTreeNode) iterator.next();
			registerNode( httpServer, dNode, dir + dNode.getName() + "/", fileTree );
		}
	}

	/* start an http server whose sole job in life is to
	 * list files to be downloaded by people browsing
	 * the site.
	 */
	private synchronized void startHTTPServer( final FileTree fileTree, int port ) throws IOException {
		Properties properties = new Properties();
		properties.setProperty( "port", String.valueOf( port ) );
		properties.setProperty( "logger.level", "debug" );
		httpserver = new net.sf.ooweb.Server( new Configuration( properties ) );

		/*
		FileTreeNode root = (FileTreeNode) files.getRoot();
		synchronized( root ){
			registerNode( httpserver, root, "/", files );
		}
		*/

		httpserver.setDynamicRegister( new Lambda1(){
			public Object invoke( Object o ){
				String[] paths = (String[]) o;
				FileTreeNode node = fileTree.findNode( paths );

				if ( node != null ){
					return createNodeHandler( fileTree, node );
				}

				return null;
			}
		});
		
		/* the http server */
		new Thread(){
			public void run(){
				httpserver.listen();
			}
		}.start();
	}

	private void addBar( final JTabbedPane space, final JComponent bar, final String title ){
		SwingUtilities.invokeLater( new Runnable(){

			public void run(){
				// space.add( Box.createVerticalStrut( 5 ) );
				space.add( title, bar );
				space.revalidate();
			}
		});
	}

	private void removeBar( JComponent space, JComponent bar ){
		space.remove( bar );
		space.revalidate();
	}

	/*
	private void refresh( JComponent space ){
		space.revalidate();
	}
	*/

	private void addUploadBar( JComponent bar, String title ){
		addBar( uploads, bar, title );
	}

	/*
	private void refreshUploads(){
		refresh( uploads );
	}
	*/

	private void removeUploadBar( JComponent bar ){
		removeBar( uploads, bar );
	}

	private void addDownloadBar( JComponent bar, String title ){
		addBar( downloads, bar, title );
	}

	private void removeDownloadBar( JComponent bar ){
		removeBar( downloads, bar );
	}

	/** Dialog where user can select YES or NO
	 */
	private class OKDialog extends JDialog {

		private int state = YES;

		public OKDialog( JFrame frame, int files, long size, String ip ){

			super( frame, true );
			this.setSize( 300, 200 );
			JPanel panel = new JPanel();
			this.getContentPane().add( panel );

			Box layout = Box.createVerticalBox();
			panel.add( layout );

			JTextArea area = new JTextArea( ip + " wants to send you " + files + " files, a total of size = " + size + " bytes" );
			area.setLineWrap( true );
			area.setWrapStyleWord( true );
			area.setEditable( false );
			layout.add( area );
			layout.add( Box.createVerticalStrut( 10 ) );

			final JDialog dialog = this;
			final Lambda0 close = new Lambda0(){
				public Object invoke(){
					dialog.dispose();
					return null;
				}
			};

			Box buttons = Box.createHorizontalBox();
			JButton yes = new JButton( "OK" );
			JButton no = new JButton( "No!" );

			yes.addActionListener( new ActionListener(){
				public void actionPerformed( ActionEvent action ){
					yes();
					try{
						close.invoke();
					} catch ( Exception ex ){
					}
				}
			});

			no.addActionListener( new ActionListener(){
				public void actionPerformed( ActionEvent action ){
					no();
					try{
						close.invoke();
					} catch ( Exception ex ){
					}
				}
			});

			buttons.add( yes );
			buttons.add( Box.createHorizontalStrut( 5 ) );
			buttons.add( no );
			
			layout.add( buttons );
		}

		private void no(){
			this.state = NO;
		}

		private void yes(){
			this.state = YES;
		}

		public int getResponse(){
			return this.state;
		}
	}

	/** Receive a bunch of files. Protocol works like this
	 * 1. Sender sends number of files
	 * 2. Sender sends combined size of all files
	 * 3. Receiver sends back YES or NO to continue the transfer or not
	 * 4. For each file loop steps 5-9
	 * 5. Sender sends filename
	 * 6. Sender sends filetype( FILE or DIRECTORY )
	 * 7. If filetype is FILE the size of the file is sent
	 * 8. If filetype is FILE the contents of the file is sent
	 * 9. If filetype is DIRECTORY the directory is created
	 */
	private void addClient( final Socket client ){
		System.out.println( "Adding client" );
		final JFrame frame = this;
		Thread thread = new Thread(){

			private boolean okToReceiveFile( int files, long size ){
				OKDialog ok = new OKDialog( frame, files, size, client.getInetAddress().getHostAddress() );
				ok.setLocation( frame.getLocationOnScreen() );
				ok.setVisible( true );

				return ok.getResponse() == YES;
			}

			private String getDirectory() throws IOException {
				JFileChooser chooser = new JFileChooser();
				chooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
				int ret = chooser.showOpenDialog( frame );
				if ( ret == JFileChooser.APPROVE_OPTION ){
					return chooser.getSelectedFile().getAbsolutePath();
				}
				throw new IOException( "No directory chosen" );
			}

			private boolean receiveFile( final JComponent add, String filename, long size, final Lambda1 updateLambda, MutableBoolean canceled ) throws IOException {
				InputStream input = new DataInputStream( client.getInputStream() );
				OutputStream output = new BufferedOutputStream( new DataOutputStream( new FileOutputStream( new File( filename ) ) ) );

				Lambda1 addComponent = new Lambda1(){
					public Object invoke( Object arg ){
						final JComponent jarg = (JComponent) arg;
						jarg.setAlignmentX( JComponent.LEFT_ALIGNMENT );
						SwingUtilities.invokeLater( new Runnable(){
							public void run(){
								add.add( jarg );
							}
						});
						// addDownloadBar( jarg );
						return null;
					}
				};
				Transfer transfer = new Transfer( input, output, addComponent, filename, size, client.getInetAddress().getHostAddress(), updateLambda, canceled );
				boolean result = transfer.transfer();

				output.flush();

				return result;
			}
			
			private int receiveNumberOfFiles() throws IOException {
				return new DataInputStream( client.getInputStream() ).readInt();
			}

			private long receiveSize() throws IOException {
				return new DataInputStream( client.getInputStream() ).readLong();
			}
			
			private long receiveFileSize() throws IOException {
				return new DataInputStream( client.getInputStream() ).readLong();
			}
			
			private int receiveFileType() throws IOException {
				return new DataInputStream( client.getInputStream() ).readInt();
			}

			private String receiveFileName() throws IOException {
				byte[] buf = new byte[ FILENAME_SIZE ];
				// System.out.println( "Receiving filename. Ready = " + client.getInputStream().available() );
				DataInputStream stream = new DataInputStream( client.getInputStream() );
				for ( int i = 0; i < FILENAME_SIZE; i++ ){
					buf[ i ] = stream.readByte();
				}
				// System.out.println( "Received bytes: " + bytes );

				return new String( buf ).trim();
			}

			/* send a '1' meaning ok to send
			 */
			private void sendOk() throws IOException {
				DataOutputStream stream = new DataOutputStream( client.getOutputStream() );
				stream.writeByte( YES );
				stream.flush();
			}

			/* send a '0' meaning not ok to send
			 */
			private void sendNotOk() throws IOException {
				DataOutputStream stream = new DataOutputStream( client.getOutputStream() );
				stream.writeByte( NO );
				stream.flush();
			}

			public void run(){
				try{
					// System.out.println( "Receive number of files" );
					final int files = receiveNumberOfFiles();

					final long size = receiveSize();
					// System.out.println( "Received size = " + size );
					if ( okToReceiveFile( files, size ) ){
						String directory = getDirectory();
						sendOk();

						final JComponent description = Box.createVerticalBox();
						description.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );
						description.add( new JLabel( "From: " + client.getInetAddress().getHostAddress() ) );
						addDownloadBar( description, client.getInetAddress().getHostAddress() );
						description.add( Box.createVerticalStrut( 5 ) );
						final JLabel info = new JLabel();
						description.add( info );
						description.add( Box.createVerticalStrut( 5 ) );

						final SpeedLabel speed = new SpeedLabel();
						final JProgressBar totalProgress = new JProgressBar( 0, 100 );
						final MutableLong mutableLong = new MutableLong();

						Lambda1 updateTotalProgress = new Lambda1(){
							public Object invoke( Object o ){
								mutableLong.add( ((Long) o).longValue() );
								speed.update( mutableLong.getValue() );
								totalProgress.setValue( (int)( mutableLong.getValue() * 100.0 / size) );
								return null;
							}
						};

						description.add( speed );
						description.add( totalProgress );

						JButton details = new JButton( "Show details" );
						details.setToolTipText( "Show more information about the transfer" );
						description.add( Box.createVerticalStrut( 5 ) );
						final Box buttons = Box.createHorizontalBox();
						buttons.setAlignmentX( JComponent.LEFT_ALIGNMENT );
						buttons.add( details );
						buttons.add( Box.createHorizontalStrut( 10 ) );
						
						final MutableBoolean canceled = new MutableBoolean( false );
						final Lambda0 addRemoveButton = new Lambda0(){
							public Object invoke(){
								SwingUtilities.invokeLater( new Runnable(){
									public void run(){
										if ( canceled.isTrue() ){
											info.setText( "Canceled!" );
										} else {
											info.setText( "Done!" );
										}


										JButton remove = new JButton( "Remove transfer" );
										remove.setToolTipText( "Removes this transfer window from the view" );
										buttons.add( Box.createHorizontalStrut( 5 ) );
										buttons.add( remove );
										remove.addActionListener( new ActionListener(){
											public void actionPerformed( ActionEvent action ){
												removeDownloadBar( description );
											}
										});
									}
								});

								return null;
							}
						};

						JButton cancel = new JButton( "Cancel" );
						cancel.setToolTipText( "Cancel this transfer" );
						buttons.add( cancel );
						description.add( buttons );

						cancel.addActionListener( new ActionListener(){
							public void actionPerformed( ActionEvent action ){
								canceled.setTrue();
								try{
									addRemoveButton.invoke();
								} catch ( Exception ex ){
								}
							}
						});

						final Box addMoreBox = Box.createVerticalBox();
						final JComponent addMore = new JScrollPane( addMoreBox );
						addMore.setVisible( false );
						addMore.setAlignmentX( JComponent.LEFT_ALIGNMENT );
						description.add( addMore );

						details.addActionListener( new ActionListener(){
							private boolean set = false;
							public void actionPerformed( ActionEvent action ){
								set = ! set;
								addMore.setVisible( set );
							}
						});

						for ( int i = 0; i < files && canceled.isFalse(); i++ ){

							// System.out.println( "Receiving file " + i );

							String filename = receiveFileName();
							System.out.println( "Receiving Filename = '" + filename + "'" );
							String all = directory + "/" + filename;
							int type = receiveFileType();
							if ( type == DIRECTORY ){
								// System.out.println( "Creating directory " + all );
								new File( all ).mkdirs();
							} else {
								long fileSize = receiveFileSize();
								// System.out.println( "Received filesize = " + fileSize );
								if ( receiveFile( addMoreBox, all, fileSize, updateTotalProgress, canceled ) ){
									System.out.println( "Done receiving file" );
								} else {
									System.out.println( "Error receiving file" );
								}
							}
						}

						if ( canceled.isFalse() ){
							try{
								addRemoveButton.invoke();
							} catch ( Exception ex ){
							}
						}
					} else {
						sendNotOk();
					}
					client.close();
				} catch ( IOException ie ){
					ie.printStackTrace();
					try{
						client.close();
					} catch ( IOException ie2 ){
						System.out.println( "Could not close client socket" );
						ie2.printStackTrace();
					}
				} finally {
				}
			}
		};

		thread.start();
	}

	/** Send a bunch of files. Protocol should work this way:
	 * 1. Send total number of files( including recursing through directories )
	 * 2. Send total number of bytes of all files
	 * 3. Wait for OK to continue or not ok to cancel
	 * 4. For each file loop steps 5-8
	 * 5. Send filename
	 * 6. Send filetype
	 * 7. If filetype is FILE, send size of file
	 * 8. If filetype is FILE, send contents of file
	 */
	public void sendFile( final Buddy buddy, final File[] files ){
		Thread thread = new Thread(){

			public int countFiles( File[] files ){
				int total = 0;
				for ( int i = 0; i < files.length; i++ ){
					if ( files[ i ].isDirectory() ){
						total += countFiles( files[ i ].listFiles() ) + 1;
					} else {
						total++;
					}
				}
				return total;
			}

			public long countSize( File[] files ){
				long total = 0;
				for ( int i = 0; i < files.length; i++ ){
					if ( files[ i ].isDirectory() ){
						total += countSize( files[ i ].listFiles() );
					} else {
						total += files[ i ].length();
					}
				}
				return total;
			}

			private void sendSize( long size, Socket socket ) throws IOException {
				DataOutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );
				output.writeLong( size );
				output.flush();
			}

			private void sendType( int type, Socket socket ) throws IOException {
				DataOutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );
				output.writeInt( type );
				output.flush();
			}

			private void sendFileSize( File file, Socket socket ) throws IOException {
				DataOutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );
				long size = file.length();
				output.writeLong( size );
				output.flush();
			}

			private void sendNumberOfFiles( int num, Socket socket ) throws IOException {
				DataOutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );
				output.writeInt( num );
				output.flush();
			}

			private JComponent createDescription(){
				JComponent description = Box.createVerticalBox();
				JLabel to = new JLabel( "To: " + buddy.getName() );
				to.setAlignmentX( JComponent.LEFT_ALIGNMENT );
				description.add( to );
				description.add( Box.createVerticalStrut( 3 ) );
				JLabel ip = new JLabel( "IP: " + buddy.getIP() + " Port: " + buddy.getPort() );
				ip.setAlignmentX( JComponent.LEFT_ALIGNMENT );
				description.add( ip );
				return description;
			}

			private boolean canSend( final Socket socket ) throws IOException {
				DataInputStream stream = new DataInputStream( socket.getInputStream() );
				byte b = stream.readByte();
				return b == YES;
			}

			private void sendFile( final JComponent box, File file, Socket socket, Lambda1 updateLambda, MutableBoolean canceled ) throws IOException {
				InputStream input = new DataInputStream( new BufferedInputStream( new FileInputStream( file ) ) );
				OutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );
				Lambda1 addComponent = new Lambda1(){
					public Object invoke( Object arg ){
						final JComponent jarg = (JComponent) arg;
						jarg.setAlignmentX( JComponent.LEFT_ALIGNMENT );
						SwingUtilities.invokeLater( new Runnable(){
							public void run(){
								box.add( jarg );
							}
						});
						return null;
					}
				};
				Transfer transfer = new Transfer( input, output, addComponent, file.getName(), file.length(), socket.getInetAddress().getHostAddress(), updateLambda, canceled );
				transfer.transfer();
				output.flush();
			}

			private void sendFileName( String filename, Socket socket ) throws IOException {

				DataOutputStream output = new DataOutputStream( new BufferedOutputStream( socket.getOutputStream() ) );

				/* Send the filename */
				new PrintStream( output ).print( filename );
				int total = 0;

				/* Then send the rest of the bits as filler, 1024 - size */
				for ( int i = filename.length(); i < FILENAME_SIZE; i++ ){
					total++;
					byte b = ' ';
					output.write( b );
				}
				// System.out.println( "Sent total of " + (filename.length() + total) + " bytes" );
				output.flush();
			}

			private List getSubFiles( File dir, String base ){
				List pairs = new ArrayList();

				File[] subs = dir.listFiles();
				for ( int i = 0; i < subs.length; i++ ){
					File file = subs[ i ];
					if ( file.isDirectory() ){
						pairs.add( new FilePair( file, base + file.getName() + "/" ) );
						pairs.addAll( getSubFiles( file, base + file.getName() + "/" ) );
					} else {
						pairs.add( new FilePair( file, base + file.getName() ) );
					}
				}

				return pairs;
			}

			private List getAllFiles( String base ){
				List pairs = new ArrayList();

				for ( int i = 0 ; i < files.length; i++ ){
					File file = files[ i ];
					if ( file.isDirectory() ){
						pairs.add( new FilePair( file, base + file.getName() + "/" ) );
						pairs.addAll( getSubFiles( file, base + file.getName() + "/" ) );
					} else {
						pairs.add( new FilePair( file, base + file.getName() ) );
					}
				}

				final List dirs = new ArrayList();
				final List files = new ArrayList();
				try{
					Lambda1.foreach( pairs, new Lambda1(){
						public Object invoke( Object o ){
							FilePair pair = (FilePair) o;
							if ( pair.isDirectory() ){
								dirs.add( pair );
							} else {
								files.add( pair );
							}
							return null;
						}
					});
				} catch ( Exception ex ){
				}

				List all = new ArrayList();
				all.addAll( dirs );
				all.addAll( files );

				return all;
			}

			public void run(){
				final int numberOfFiles = countFiles( files );
				final long totalSize = countSize( files );

				// System.out.println( "Sending " + numberOfFiles + " size = " + totalSize );
					
				final JComponent description = createDescription();
				description.setBorder( BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) );
				addUploadBar( description, buddy.getName() );
				final JLabel info = new JLabel();
				description.add( info );
				description.add( Box.createVerticalStrut( 3 ) );
				final MutableLong mutableLong = new MutableLong();
				final JProgressBar totalProgress = new JProgressBar( 0, 100 );
				final SpeedLabel speed = new SpeedLabel();
				final Lambda1 updateProgressLambda = new Lambda1(){
					public Object invoke( Object o ){
						mutableLong.add( ((Long) o).longValue() );
						speed.update( mutableLong.getValue() );
						totalProgress.setValue( (int)( mutableLong.getValue() * 100.0 / totalSize) );
						return null;
					}
				};
				
				final Box buttons = Box.createHorizontalBox();

				final Lambda0 addRemoveButton = new Lambda0(){ 

					public Object invoke(){
						SwingUtilities.invokeLater( new Runnable(){
							public void run(){
								JButton remove = new JButton( "Remove transfer" );
								remove.setToolTipText( "Removes this transfer window from the view" );
								buttons.add( Box.createHorizontalStrut( 5 ) );
								buttons.add( remove );
								remove.addActionListener( new ActionListener(){
									public void actionPerformed( ActionEvent action ){
										removeUploadBar( description );
									}
								});
							}
						});

						return null;
					}
				};

				final MutableBoolean canceled = new MutableBoolean( false );
				description.add( speed );
				description.add( totalProgress );
				description.add( Box.createVerticalStrut( 3 ) );
				JButton details = new JButton( "Show details" );
				details.setToolTipText( "Show more information about the transfer" );
				JButton cancel = new JButton( "Cancel" );
				cancel.setToolTipText( "Cancel this transfer" );
				buttons.add( details );
				buttons.add( Box.createHorizontalStrut( 5 ) );
				buttons.add( cancel );
				buttons.setAlignmentX( JComponent.LEFT_ALIGNMENT );

				cancel.addActionListener( new ActionListener(){
					public void actionPerformed( ActionEvent action ){
						canceled.setTrue();
						try{
							addRemoveButton.invoke();
						} catch ( Exception ex ){
						}
					}
				});

				description.add( buttons );
				description.add( Box.createVerticalStrut( 5 ) );
				final Box addMoreBox = Box.createVerticalBox();
				final JComponent addMore = new JScrollPane( addMoreBox );
				addMore.setVisible( false );
				description.add( addMore );
				details.addActionListener( new ActionListener(){
					private boolean set = false;
					public void actionPerformed( ActionEvent action ){
						set = ! set;
						addMore.setVisible( set );
					}
				});

				try{
					final Socket socket = new Socket( buddy.getIP(), buddy.getPort() );
					// System.out.println( "Send filename" );
					sendNumberOfFiles( numberOfFiles, socket );
					// System.out.println( "Send size" );
					sendSize( totalSize, socket );

					if ( canSend( socket ) ){
						try{
							List pairs = getAllFiles( "" );
							Lambda1.foreach( pairs, new Lambda1(){
								public Object invoke( Object o ){
									try{
										FilePair pair = (FilePair) o;
										System.out.println( "Sending " + pair.getName() );
										sendFileName( pair.getName(), socket );
										if ( pair.isDirectory() ){
											sendType( DIRECTORY, socket );
										} else {
											sendType( FILE, socket );
											sendFileSize( pair.getFile(), socket );
											sendFile( addMoreBox, pair.getFile(), socket, updateProgressLambda, canceled );
										}
									} catch ( IOException ie ){
										ie.printStackTrace();
									}
									return null;
								}
							});
						} catch ( Exception ex ){
						}
						System.out.println( "Done sending files" );
						SwingUtilities.invokeLater( new Runnable(){
							public void run(){
								if ( canceled.isTrue() ){
									info.setText( "Canceled!" );
								} else {
									info.setText( "Done!" );
								}
							}
						});
					} else {
						throw new IOException( "Transfer denied" );
					}
					socket.close();
				} catch ( IOException ie ){
					ie.printStackTrace();
					SwingUtilities.invokeLater( new Runnable(){
						public void run(){
							info.setText( "Error in transfer" );
						}
					});
				}

				if ( canceled.isFalse() ){
					try{
						addRemoveButton.invoke();
					} catch ( Exception ex ){
					}
				}
			}

		};

		thread.start();
	}

	private class FilePair{
		private String name;
		private File file;

		public FilePair( File file, String path ){
			this.name = path;
			this.file = file;
		}

		public String getName(){
			return this.name;
		}

		public boolean isDirectory(){
			return this.file.isDirectory();
		}

		public File getFile(){
			return file;
		}
	}

	public int getListenPort(){
		return listenPort;
	}

	public void setListenPort( int port ){
		this.listenPort = port;
	}

	public static void main( String[] args ){
		SwingUtilities.invokeLater(
			new Runnable(){
				public void run(){
					try{
						Reft reft = new Reft();
						reft.setVisible( true );
					} catch ( IOException ie ){
						ie.printStackTrace();
					}
				}
			}
		);
	}

}
